#!/bin/sh
# fix filewave server and mdm server folders&files permissions & ownership
# updated by christiang@filewave.com , Oct-22-2012

# check root 
if [ "$(id -u)" != "0" ] ; then echo "This script must be run as root" 1>&2; exit 1; fi
# check if fwxserver running 
if [ "$(ps ax | grep -i /usr/local/sbin/fwxserver | egrep -v 'grep' | wc -l)" -gt "0" ] ; then echo "Aborting: filewave server is running" 1>&2; exit 1; fi
# check if postgres running 
if [ "$(ps ax | grep -i /usr/local/filewave/postgresql/bin/postmaster | egrep -v 'grep' | wc -l)" -gt "0" ] ; then echo "Aborting: postgres server is running" 1>&2; exit 1; fi

echo -n "Fixing fwxserver folder permissions"
chown root:wheel /usr/local/filewave/fwxserver
find /usr/local/filewave/fwxserver -maxdepth 1 -type d -exec /bin/chmod 755 {} \;
echo "  Done"

echo -n "Fixing Data Folder Ownership"
chown -R root:wheel /usr/local/filewave/fwxserver/Data\ Folder
echo "  Done"
echo -n "Fixing Data Folder File Access Rights"
find /usr/local/filewave/fwxserver/Data\ Folder -type f -print0|xargs -0 /bin/chmod 644
echo "  Done" 
echo -n "Fixing Data Folder Subfolder Access Rights"
find /usr/local/filewave/fwxserver/Data\ Folder -type d -print0|xargs -0 /bin/chmod 755 
echo "  Done"

echo -n "Fixing DB folder permissions"
#the apache user and group are called apache on linux, but _www on mac
APACHENAME="apache"
if [ "$(uname -a |grep Darwin|wc -l)" -eq "1" ] ; then APACHENAME="_www" ; fi
chown root:$APACHENAME /usr/local/filewave/fwxserver/DB
chmod g+w /usr/local/filewave/fwxserver/DB
echo "  Done"
echo -n "Fixing sqlite file permissions"
chown root:$APACHENAME /usr/local/filewave/fwxserver/DB/*.sqlite*
chmod 664 /usr/local/filewave/fwxserver/DB/*.sqlite
echo "  Done"

version=$(/usr/local/sbin/fwxserver -V |awk {'print $2'}| sed -e "s/\.//g")
if [ "$version" -ge "570" ]; then 
	echo -n "Postgres installation found, fixing pg_data permissions"
	chown -R postgres:daemon /usr/local/filewave/fwxserver/DB/pg_data
	find /usr/local/filewave/fwxserver/DB/pg_data -type f -print0|xargs -0 /bin/chmod 600
	find /usr/local/filewave/fwxserver/DB/pg_data -type d -print0|xargs -0 /bin/chmod 700
	echo "  Done"
	echo "Fixing MDM directory ownership"
	cd /usr/local/filewave
	echo -n "Fixing log,certs,ipa directory ownership & permissions"
	chown -R $APACHENAME:$APACHENAME log certs ipa
    chown postgres:daemon certs/postgres.*
	chmod 775 log certs ipa
		chmod 664 certs/dummy.* certs/server.*
		chmod 600 certs/apn.key
		chmod 644 certs/apn.crt
        chmod 664 certs/postgres.crt
        chmod 600 certs/postgres.key
		chmod 664 log/*
	echo " Done"
	echo -n "Fixing bin & django ownership & permissions"
	chown -R root:wheel bin postgresql
		chmod a+x bin/*
		chown postgres:daemon postgresql/conf postgresql/log		
	chown -R root:$APACHENAME python django
	echo "  Done"	
fi

echo "Done! Please start the server"
